Attribute VB_Name = "modHaupt"
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliSeconds As Long)

Public Declare Function Inp Lib "inpout32.dll" _
Alias "Inp32" (ByVal PortAddress As Integer) As Integer
Public Declare Sub Out Lib "inpout32.dll" _
Alias "Out32" (ByVal PortAddress As Integer, ByVal Value As Integer)


Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Type OPENFILENAME
    lStructSize As Long
    hwnd As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'//
'// DialogFile Function
'//
'// Description:
'// Displays the File Open/Save As common dialog boxes.
'//
'// Syntax:
'// StrVar = DialogFile(hWnd, IntVar, StrVar, StrVar, StrVar, StrVar, StrVar)
'//
'// Example:
'// szFilename = DialogFile(Me.hWnd, 1, "Open", "MyFileName.doc", "Documents" & Chr(0) & "*.doc" & Chr(0) & "All files" & Chr(0) & "*.*", App.Path, "doc")
'//
'// Please note that the szFilter var works a bit differently
'// from the filter property associated with the common dialog
'// control. Instead of separating the differents parts of the
'// string with pipe chars, |, you should use null chars, Chr(0),
'// as separators.
Public Function DialogFile(hwnd As Long, wMode As Integer, szDialogTitle As String, szFilename As String, szFilter As String, szDefDir As String, szDefExt As String) As String
    Dim X As Long, OFN As OPENFILENAME, szFile As String, szFileTitle As String
    OFN.lStructSize = Len(OFN)
    OFN.hwnd = hwnd
    OFN.lpstrTitle = szDialogTitle
    OFN.lpstrFile = szFilename & String$(250 - Len(szFilename), 0)
    OFN.nMaxFile = 255
    OFN.lpstrFileTitle = String$(255, 0)
    OFN.nMaxFileTitle = 255
    OFN.lpstrFilter = szFilter
    OFN.nFilterIndex = 1
    OFN.lpstrInitialDir = szDefDir
    OFN.lpstrDefExt = szDefExt

   If wMode = 1 Then
        OFN.Flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
        X = GetOpenFileName(OFN)
    Else
        OFN.Flags = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT Or OFN_PATHMUSTEXIST
        X = GetSaveFileName(OFN)
    End If

    If X <> 0 Then
        '// If InStr(OFN.lpstrFileTitle, Chr$(0)) > 0 Then
        '//     szFileTitle = Left$(OFN.lpstrFileTitle, InStr(OFN.lpstrFileTitle, Chr$(0)) - 1)
        '// End If
        If InStr(OFN.lpstrFile, Chr$(0)) > 0 Then
            szFile = VBA.Left$(OFN.lpstrFile, InStr(OFN.lpstrFile, Chr$(0)) - 1)
        End If
        '// OFN.nFileOffset is the number of characters from the beginning of the
        '// full path to the start of the file name
        '// OFN.nFileExtension is the number of characters from the beginning of the
        '// full path to the file's extention, including the (.)
        '// MsgBox "File Name is " & szFileTitle & Chr$(13) & Chr$(10) & "Full path and file is " & szFile, , "Open"
        '// DialogFile = szFile & "|" & szFileTitle
        DialogFile = szFile
    Else
        DialogFile = ""
    End If
End Function


Public Function GetFileName(strPathAndFile As String) As String
Dim tmp As String, i As Integer
tmp = StrReverse$(strPathAndFile)
tmp = Replace$(tmp, "/", "\")
i = InStr(tmp, "\")
If i > 0 Then
   tmp = VBA.Left$(tmp, (i - 1))
   GetFileName = StrReverse$(tmp)
Else
   GetFileName = strPathAndFile
End If
End Function

Public Function FuehrendeNullen(Wert As String, Anzahl As Integer) As String
    Dim tmp As String
    tmp = Trim$(Wert)
    If Anzahl <= 0 Or Anzahl <= Len(tmp) Then
       FuehrendeNullen = tmp
       Exit Function
    End If
    FuehrendeNullen = String$(Anzahl - Len(tmp), "0") + tmp
End Function

Public Function BitIst(Wert As Long, Bit As Byte) As Byte
    If Wert > 65535 Then MsgBox "Wert ist grer als 16 Bit, Abbruch !" + Space$(5), vbExclamation + vbOKOnly, "Fehler !": Exit Function
    If Bit > 15 Or Bit < 0 Then MsgBox "Bit auerhalb '0-15', Abbruch !" + Space$(5), vbExclamation + vbOKOnly, "Fehler !": Exit Function
    Dim a As Long, b(0 To 15) As Byte
    a = Wert
    If a - 32768 >= 0 Then b(15) = 1: a = a - 32768 Else b(15) = 0
    If a - 16384 >= 0 Then b(14) = 1: a = a - 16384 Else b(14) = 0
    If a - 8192 >= 0 Then b(13) = 1: a = a - 8192 Else b(13) = 0
    If a - 4096 >= 0 Then b(12) = 1: a = a - 4096 Else b(12) = 0
    If a - 2048 >= 0 Then b(11) = 1: a = a - 2048 Else b(11) = 0
    If a - 1024 >= 0 Then b(10) = 1: a = a - 1024 Else b(10) = 0
    If a - 512 >= 0 Then b(9) = 1: a = a - 512 Else b(9) = 0
    If a - 256 >= 0 Then b(8) = 1: a = a - 256 Else b(8) = 0
    If a - 128 >= 0 Then b(7) = 1: a = a - 128 Else b(7) = 0
    If a - 64 >= 0 Then b(6) = 1: a = a - 64 Else b(6) = 0
    If a - 32 >= 0 Then b(5) = 1: a = a - 32 Else b(5) = 0
    If a - 16 >= 0 Then b(4) = 1: a = a - 16 Else b(4) = 0
    If a - 8 >= 0 Then b(3) = 1: a = a - 8 Else b(3) = 0
    If a - 4 >= 0 Then b(2) = 1: a = a - 4 Else b(2) = 0
    If a - 2 >= 0 Then b(1) = 1: a = a - 2 Else b(1) = 0
    If a - 1 >= 0 Then b(0) = 1: a = a - 1 Else b(0) = 0
    BitIst = b(Bit)
End Function

Public Sub BitSetzen(Wert As Long, Bit As Byte)
    If Wert > 65535 Then MsgBox "Wert ist grer als 16 Bit, Abbruch !" + Space$(5), vbExclamation + vbOKOnly, "Fehler !": Exit Sub
    If Bit > 15 Or Bit < 0 Then MsgBox "Bit auerhalb '0-15', Abbruch !" + Space$(5), vbExclamation + vbOKOnly, "Fehler !": Exit Sub
    Dim a As Long, b(0 To 15) As Byte
    a = Wert
    If a - 32768 >= 0 Then b(15) = 1: a = a - 32768 Else b(15) = 0
    If a - 16384 >= 0 Then b(14) = 1: a = a - 16384 Else b(14) = 0
    If a - 8192 >= 0 Then b(13) = 1: a = a - 8192 Else b(13) = 0
    If a - 4096 >= 0 Then b(12) = 1: a = a - 4096 Else b(12) = 0
    If a - 2048 >= 0 Then b(11) = 1: a = a - 2048 Else b(11) = 0
    If a - 1024 >= 0 Then b(10) = 1: a = a - 1024 Else b(10) = 0
    If a - 512 >= 0 Then b(9) = 1: a = a - 512 Else b(9) = 0
    If a - 256 >= 0 Then b(8) = 1: a = a - 256 Else b(8) = 0
    If a - 128 >= 0 Then b(7) = 1: a = a - 128 Else b(7) = 0
    If a - 64 >= 0 Then b(6) = 1: a = a - 64 Else b(6) = 0
    If a - 32 >= 0 Then b(5) = 1: a = a - 32 Else b(5) = 0
    If a - 16 >= 0 Then b(4) = 1: a = a - 16 Else b(4) = 0
    If a - 8 >= 0 Then b(3) = 1: a = a - 8 Else b(3) = 0
    If a - 4 >= 0 Then b(2) = 1: a = a - 4 Else b(2) = 0
    If a - 2 >= 0 Then b(1) = 1: a = a - 2 Else b(1) = 0
    If a - 1 >= 0 Then b(0) = 1: a = a - 1 Else b(0) = 0
    b(Bit) = 1
    a = 0
    If b(0) = 1 Then a = a + 1
    If b(1) = 1 Then a = a + 2
    If b(2) = 1 Then a = a + 4
    If b(3) = 1 Then a = a + 8
    If b(4) = 1 Then a = a + 16
    If b(5) = 1 Then a = a + 32
    If b(6) = 1 Then a = a + 64
    If b(7) = 1 Then a = a + 128
    If b(8) = 1 Then a = a + 256
    If b(9) = 1 Then a = a + 512
    If b(10) = 1 Then a = a + 1024
    If b(11) = 1 Then a = a + 2048
    If b(12) = 1 Then a = a + 4096
    If b(13) = 1 Then a = a + 8192
    If b(14) = 1 Then a = a + 16384
    If b(15) = 1 Then a = a + 32768
    Wert = a
End Sub

Public Sub BitLoeschen(Wert As Long, Bit As Byte)
    If Wert > 65535 Then MsgBox "Wert ist grer als 16 Bit, Abbruch !" + Space$(5), vbExclamation + vbOKOnly, "Fehler !": Exit Sub
    If Bit > 15 Or Bit < 0 Then MsgBox "Bit auerhalb '0-15', Abbruch !" + Space$(5), vbExclamation + vbOKOnly, "Fehler !": Exit Sub
    Dim a As Long, b(0 To 15) As Byte
    a = Wert
    If a - 32768 >= 0 Then b(15) = 1: a = a - 32768 Else b(15) = 0
    If a - 16384 >= 0 Then b(14) = 1: a = a - 16384 Else b(14) = 0
    If a - 8192 >= 0 Then b(13) = 1: a = a - 8192 Else b(13) = 0
    If a - 4096 >= 0 Then b(12) = 1: a = a - 4096 Else b(12) = 0
    If a - 2048 >= 0 Then b(11) = 1: a = a - 2048 Else b(11) = 0
    If a - 1024 >= 0 Then b(10) = 1: a = a - 1024 Else b(10) = 0
    If a - 512 >= 0 Then b(9) = 1: a = a - 512 Else b(9) = 0
    If a - 256 >= 0 Then b(8) = 1: a = a - 256 Else b(8) = 0
    If a - 128 >= 0 Then b(7) = 1: a = a - 128 Else b(7) = 0
    If a - 64 >= 0 Then b(6) = 1: a = a - 64 Else b(6) = 0
    If a - 32 >= 0 Then b(5) = 1: a = a - 32 Else b(5) = 0
    If a - 16 >= 0 Then b(4) = 1: a = a - 16 Else b(4) = 0
    If a - 8 >= 0 Then b(3) = 1: a = a - 8 Else b(3) = 0
    If a - 4 >= 0 Then b(2) = 1: a = a - 4 Else b(2) = 0
    If a - 2 >= 0 Then b(1) = 1: a = a - 2 Else b(1) = 0
    If a - 1 >= 0 Then b(0) = 1: a = a - 1 Else b(0) = 0
    b(Bit) = 0
    a = 0
    If b(0) = 1 Then a = a + 1
    If b(1) = 1 Then a = a + 2
    If b(2) = 1 Then a = a + 4
    If b(3) = 1 Then a = a + 8
    If b(4) = 1 Then a = a + 16
    If b(5) = 1 Then a = a + 32
    If b(6) = 1 Then a = a + 64
    If b(7) = 1 Then a = a + 128
    If b(8) = 1 Then a = a + 256
    If b(9) = 1 Then a = a + 512
    If b(10) = 1 Then a = a + 1024
    If b(11) = 1 Then a = a + 2048
    If b(12) = 1 Then a = a + 4096
    If b(13) = 1 Then a = a + 8192
    If b(14) = 1 Then a = a + 16384
    If b(15) = 1 Then a = a + 32768
    Wert = a
End Sub

Public Function AdresseTeilen(Wert As Long, Optional Oben As Boolean = False) As Long
    If Wert > 65535 Then MsgBox "Wert ist grer als 16 Bit, Abbruch !" + Space$(5), vbExclamation + vbOKOnly, "Fehler !": Exit Function
    Dim a As Long, b(0 To 15) As Byte, c As Byte
    a = Wert
    c = IIf(Oben = True, 8, 0)
    If a - 32768 >= 0 Then b(15) = 1: a = a - 32768 Else b(15) = 0
    If a - 16384 >= 0 Then b(14) = 1: a = a - 16384 Else b(14) = 0
    If a - 8192 >= 0 Then b(13) = 1: a = a - 8192 Else b(13) = 0
    If a - 4096 >= 0 Then b(12) = 1: a = a - 4096 Else b(12) = 0
    If a - 2048 >= 0 Then b(11) = 1: a = a - 2048 Else b(11) = 0
    If a - 1024 >= 0 Then b(10) = 1: a = a - 1024 Else b(10) = 0
    If a - 512 >= 0 Then b(9) = 1: a = a - 512 Else b(9) = 0
    If a - 256 >= 0 Then b(8) = 1: a = a - 256 Else b(8) = 0
    If a - 128 >= 0 Then b(7) = 1: a = a - 128 Else b(7) = 0
    If a - 64 >= 0 Then b(6) = 1: a = a - 64 Else b(6) = 0
    If a - 32 >= 0 Then b(5) = 1: a = a - 32 Else b(5) = 0
    If a - 16 >= 0 Then b(4) = 1: a = a - 16 Else b(4) = 0
    If a - 8 >= 0 Then b(3) = 1: a = a - 8 Else b(3) = 0
    If a - 4 >= 0 Then b(2) = 1: a = a - 4 Else b(2) = 0
    If a - 2 >= 0 Then b(1) = 1: a = a - 2 Else b(1) = 0
    If a - 1 >= 0 Then b(0) = 1: a = a - 1 Else b(0) = 0
    a = 0
    If b(c) = 1 Then a = a + 1
    If b(c + 1) = 1 Then a = a + 2
    If b(c + 2) = 1 Then a = a + 4
    If b(c + 3) = 1 Then a = a + 8
    If b(c + 4) = 1 Then a = a + 16
    If b(c + 5) = 1 Then a = a + 32
    If b(c + 6) = 1 Then a = a + 64
    If b(c + 7) = 1 Then a = a + 128
    AdresseTeilen = a
End Function

